unit uCadMedico;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TfMedicos = class(TForm)
    GroupBox1: TGroupBox;
    btnSair: TBitBtn;
    edtNome: TEdit;
    Label1: TLabel;
    edtCodMedico: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    cbEspecialidade: TComboBox;
    edtCpf: TMaskEdit;
    Panel1: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    btnSalvar: TBitBtn;
    btnDeletar: TBitBtn;
    btnAlterar: TBitBtn;
    btnNovo: TBitBtn;
    edtCrm: TMaskEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSairClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
  private
    { Private declarations }


  public
    { Public declarations }
    procedure desabilitarComponentes;
    procedure habilitarComponentes;
    procedure habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
    procedure gravarRegistro;
    procedure consulta(where: string);
    procedure deletaRegistro;

  end;

var
  fMedicos: TfMedicos;

implementation

uses uDm;

{$R *.dfm}

procedure TfMedicos.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action:= cafree;
   fMedicos:= nil;
end;

procedure TfMedicos.btnSairClick(Sender: TObject);
begin
   close;
end;

procedure TfMedicos.habilitarComponentes;
var
   i: integer;
begin

   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= true;
         (Components[i] as tEdit).Color:= clWindow;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= true;
         (Components[i] as TComboBox).Color:= clWindow;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= true;
         (Components[i] as TMaskEdit).Color:= clWindow;
      end;
   end;

   edtCodMedico.Color:= $007a513d;
   edtCodMedico.Font.Color:= clWhite;

   cbEspecialidade.Clear;
   dm.consulta('especialidade', 'especialidade', '');

   while not dm.cdsAux.Eof do
   begin
      cbEspecialidade.Items.Add(dm.cdsAux.fieldByName('especialidade').asString);
      dm.cdsAux.Next;
   end;
   cbEspecialidade.ItemIndex:= 0;
end;

procedure TfMedicos.desabilitarComponentes;
var
   i: integer;
begin

   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= false;
         (Components[i] as tEdit).clear;
         (Components[i] as tEdit).Color:= clMedGray;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= false;
         (Components[i] as TComboBox).ItemIndex:= -1;
         (Components[i] as TComboBox).Color:= clMedGray;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= false;
         (Components[i] as TMaskEdit).clear;
         (Components[i] as TMaskEdit).Color:= clMedGray;
      end;
   end;   
end;

procedure TfMedicos.FormCreate(Sender: TObject);
begin
   desabilitarComponentes;
   habilitaDesabilitaBotao(true, false, false, false);   
end;

procedure TfMedicos.BitBtn3Click(Sender: TObject);
begin
   habilitarComponentes;
   edtNome.SetFocus;
end;

procedure TfMedicos.habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
begin
   btnnovo.enabled:= Novo;
   btnDeletar.enabled:= deletar;
   btnAlterar.enabled:= alterar;
   btnSalvar.enabled:= salvar;
end;

procedure TfMedicos.btnNovoClick(Sender: TObject);
begin
   habilitaDesabilitaBotao(false, false, false, true);
   habilitarComponentes;

   consulta('');

   edtCodMedico.Text:= dm.getGenerator('gen_medico');
   dm.cds1.Insert;
   edtNome.SetFocus;
end;

procedure TfMedicos.btnSalvarClick(Sender: TObject);
begin

   if (edtNome.Text = '') or
         (edtCrm.Text = '') or
         (edtCpf.Text = '') or          
         (cbEspecialidade.Text = '') then
   begin
      messageDlg('Todos os campos so obrigatrios, preencha-os antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   try
      gravarRegistro;
      messageDlg('Registro salvo com sucesso', mtInformation, [mbOk], 0);
      except on e:exception do
         messageDlg(e.message, mtError, [mbOk], 0);
   end;

   habilitaDesabilitaBotao(true, false, false, false);
   desabilitarComponentes;
end;


procedure TfMedicos.gravarRegistro;
var
   vEspecialidade: integer;
begin
   if not dm.cds1.Active then
      raise Exception.Create('Execute uma consulta antes');

   dm.consulta('id_especialidade', 'especialidade', ' where especialidade = "' + cbEspecialidade.Text + '"');
   vEspecialidade:= dm.cdsAux.fieldByName('id_especialidade').asInteger;

   try
      with dm.cds1 do
      begin
         Edit;
         FieldByName('id_medico').AsInteger:= strToInt(edtCodMedico.Text);
         FieldByName('medico').asString:= edtNome.Text;
         FieldByName('crm').asString:= edtCrm.Text;
         FieldByName('cpf').asString:= edtCpf.Text;
         FieldByName('id_especialidade').AsInteger:= vEspecialidade;
         Post;
         ApplyUpdates(-1);
      end;
      except on  e: exception do
         messageDlg('No foi possvel salvar registro' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfMedicos.consulta(where: string);
begin

   try
      dm.cds1.Close;
      dm.sql1.CommandText:= 'select * from medico ' + where;
      dm.cds1.Open;
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfMedicos.deletaRegistro;
begin

   try
      consulta(' where id_medico = ' + edtCodMedico.Text);
      dm.cds1.Delete;
      dm.cds1.ApplyUpdates(-1);
      desabilitarComponentes;

      messageDlg('Registro deletado com sucesso', mtInformation, [mbOk], 0);

      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfMedicos.btnAlterarClick(Sender: TObject);
begin
   consulta(' where id_medico = ' + edtCodMedico.Text);
   gravarRegistro;
end;

procedure TfMedicos.btnDeletarClick(Sender: TObject);
begin
   deletaRegistro;
end;

end.
