unit uConsulta;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Mask, CheckLst;

type
  TfConsulta = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox1: TGroupBox;
    edtCodMedico: TEdit;
    edtNomeMedico: TEdit;
    edtNomePaciente: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnPesqMedico: TBitBtn;
    btnPesqPaciente: TBitBtn;
    edtCodPaciente: TEdit;
    edtDataConsulta: TMaskEdit;
    Label3: TLabel;
    BitBtn3: TBitBtn;
    clbRemedios: TCheckListBox;
    Label4: TLabel;
    mmObs: TMemo;
    Label5: TLabel;
    cbTipo: TComboBox;
    Label8: TLabel;
    btnnovo: TBitBtn;
    btnAlterar: TBitBtn;
    btnDeletar: TBitBtn;
    btnSalvar: TBitBtn;
    BitBtn4: TBitBtn;
    edtId: TEdit;
    Label9: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnPesqMedicoClick(Sender: TObject);
    procedure btnPesqPacienteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure desabilitarComponentes;
    procedure habilitarComponentes;
    procedure btnnovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure gravarRegistro;
    procedure consulta(where: string);
    procedure deletaRegistro;
    procedure btnAlterarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
        
  private
    { Private declarations }
      procedure pesquisaLookup(tabela: string; var codigo: string; var nome: string; sender: tObject);

  public
    { Public declarations }
      procedure habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
          
  end;

var
  fConsulta: TfConsulta;

implementation

uses uDm, uLookupSemBde, uPesquisas, DB, SqlExpr, uInternacao;

{$R *.dfm}



procedure TfConsulta.habilitarComponentes;
var
   i: integer;
begin

   {varre os componentes da tela e habilita os edits e comboBox}
   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= true;
         (Components[i] as tEdit).Color:= clWindow;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= true;
         (Components[i] as TComboBox).Color:= clWindow;
      end
      else if Components[i] is TMemo then
      begin
         (Components[i] as TMemo).Enabled:= true;
         (Components[i] as TMemo).Color:= clWindow;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= true;
         (Components[i] as TMaskEdit).Color:= clWindow;
      end
      else if Components[i] is TCheckListBox then
      begin
         (Components[i] as TCheckListBox).Enabled:= true;
         (Components[i] as TCheckListBox).Color:= clWindow;
      end;
   end;

   edtId.Color:= $007a513d;
   edtCodMedico.Color:= $007a513d;
   edtCodPaciente.Color:= $007a513d;
   edtNomeMedico.Color:= clInfoBk;
   edtNomePaciente.Color:= clInfoBk;

end;

procedure TfConsulta.desabilitarComponentes;
var
   i: integer;
begin
   {varre os componentes da tela e desabilita os edits e comboBox}
   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= false;
         (Components[i] as tEdit).Clear;
         (Components[i] as tEdit).Color:= clMedGray;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= false;
         (Components[i] as TComboBox).ItemIndex:= -1;
         (Components[i] as TComboBox).Color:= clMedGray;
      end
      else if Components[i] is TMemo then
      begin
         (Components[i] as TMemo).Enabled:= false;
         (Components[i] as TMemo).Clear;
         (Components[i] as TMemo).Color:= clMedGray;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= false;
         (Components[i] as TMaskEdit).Clear;
         (Components[i] as TMaskEdit).Color:= clMedGray;
      end
      else if Components[i] is TCheckListBox then
      begin
         (Components[i] as TCheckListBox).Enabled:= false;
         (Components[i] as TCheckListBox).Color:= clWindow;
      end;
   end;
end;

procedure TfConsulta.habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
begin
   {habilita ou desabilita os componentes da tela}
   btnnovo.enabled:= Novo;
   btnDeletar.enabled:= deletar;
   btnAlterar.enabled:= alterar;
   btnSalvar.enabled:= salvar;
end;

procedure TfConsulta.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   action:= cafree;
   fConsulta:= nil;
end;

procedure TfConsulta.btnPesqMedicoClick(Sender: TObject);
var
   vCod, vNome: string;
begin
   pesquisaLookup('Medico', vCod, vNome, sender);
   edtCodMedico.Text:= vcod;
   edtNomeMedico.Text:= vnome;
end;


procedure TfConsulta.pesquisaLookup(tabela: string; var codigo: string; var nome: string; sender: tObject);
var
   frm: TfPesquisas;
begin

   try
      frm:= TfPesquisas.Create(application);

      with frm do
      begin
         cbParametroPesquisa.ItemIndex:= frm.cbParametroPesquisa.Items.IndexOf(tabela);
         cbParametroPesquisaChange(Sender);
         cbParametroPesquisa.Enabled:= false;
         btnsair.Caption:= 'Selecionar';
         btnSair.Glyph:= frm.btnOk.Glyph;
         ShowModal;
      end;

      if frm.lvResult.Selected <> nil then
      begin
         codigo:= frm.lvResult.Selected.Caption;
         nome:= frm.lvResult.Selected.SubItems[0];
      end;

      finally
         frm.Free;
   end;
end;


procedure TfConsulta.btnPesqPacienteClick(Sender: TObject);
var
   vCod, vNome: string;
begin
   pesquisaLookup('Paciente', vCod, vNome, sender);
   edtCodPaciente.Text:= vcod;
   edtNomePaciente.Text:= vnome;
end;

procedure TfConsulta.FormCreate(Sender: TObject);
var
   i: integer;
begin

   with dm.q1 do
   begin
      close;
      sql.Clear;
      sql.Add(' select nomeremedio from remedio ');
      open;
   end;

   while not dm.q1.Eof do
   begin
      clbRemedios.Items.Add(dm.q1.fieldByName('nomeremedio').AsString);
      dm.q1.Next;
   end;

   habilitaDesabilitaBotao(true, false, false, false);
   desabilitarComponentes;
end;

procedure TfConsulta.BitBtn3Click(Sender: TObject);
begin
   close;
end;

procedure TfConsulta.btnnovoClick(Sender: TObject);
begin

   {habilita alguns componentes e desabilitando alguns botes}
   habilitarComponentes;
   habilitaDesabilitaBotao(false, false, false, true);

   {executa uma consulta para criar no compenente a estrutura necessria para a insero}
   consulta('');

   {pega o valor generator do banco}
   edtId.Text:= dm.getGenerator('gen_consulta');

   {gera um registro novo no componente}
   dm.cds1.Insert;
   edtDataConsulta.SetFocus;

end;

procedure TfConsulta.btnSalvarClick(Sender: TObject);
var
   i: integer;
begin

   if (edtDataConsulta.Text = '') or
         (edtCodMedico.Text = '') or
         (edtCodPaciente.Text = '') then
   begin
      messageDlg('Os campos Data da Consulta, CodMdico e CodPaciente so obrigatrios, preencha-os antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   if (not dm.convertToDate(edtDataConsulta.Text)) then
   begin
      messageDlg('Existe um valor invlido para campo data, corrja-o antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   try
      {chama a procedure para salvar os dados no banco de dados}
      gravarRegistro;

      messageDlg('Registro salvo com sucesso', mtInformation, [mbOk], 0);

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on e:exception do
         messageDlg(e.message, mtError, [mbOk], 0);
   end;

   {trata os componentes da tela}
   habilitaDesabilitaBotao(true, false, false, false);
   desabilitarComponentes;

end;


procedure TfConsulta.gravarRegistro;
var
   i: integer;
begin

   {se o clientDataset estiver inativo gera uma execption}
   if not dm.cds1.Active then
      raise Exception.Create('Execute uma consulta antes');

   {modifica os registros no clientDataSet e salva banco atraves do applyUpdates}
   try
      with dm.cds1 do
      begin
         {coloca o componente em modo de edio}
         Edit;

         {atualiza os valores dos campos no componente}
         FieldByName('id_consulta').AsInteger   := strToInt(edtId.Text);
         FieldByName('tipoConsulta').asString   := cbTipo.Text;
         FieldByName('id_medico').asInteger     := strToInt(edtCodMedico.Text);
         FieldByName('id_paciente').asInteger   := strToInt(edtCodPaciente.Text);
         FieldByName('dataConsulta').asString   := edtDataConsulta.Text;
         FieldByName('observacao').asString     := mmObs.Text;

         {escreve a modificao no registro}
         Post;

         {aplica as atualizaes no banco de dados}
         ApplyUpdates(-1);
      end;

      with dm.q1 do
      begin
         Close;
         sql.Clear;
         sql.Add('delete from consulta_remedio where id_consulta = :id_consulta ');
         ParamByName('id_consulta').AsInteger:= strToInt(edtId.Text);
         execsql;
      end;

      for i:= 0 to clbRemedios.Items.Count -1 do
      begin
         if clbRemedios.Checked[i] then
         begin
            with dm.q1 do
            begin
               Close;
               sql.Clear;
               sql.Add('insert into consulta_remedio ');
               sql.Add(' ( id_remedio,  id_consulta) ');
               sql.Add(' values ');
               sql.Add(' ((select id_remedio from remedio where nomeRemedio = :remedio), :id_consulta)');
               ParamByName('id_consulta').AsInteger:= strToInt(edtId.Text);
               ParamByName('remedio').AsString:= clbRemedios.Items.Strings[i];
               ExecSQL;
            end;
         end;
      end; 

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on  e: exception do
         messageDlg('No foi possvel salvar registro' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfConsulta.consulta(where: string);
begin

   try
      {executa uma consulta no componente}
      dm.cds1.Close;
      dm.sql1.CommandText:= 'select * from consulta ' + where;
      dm.cds1.Open;

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfConsulta.deletaRegistro;
begin

   try
      {seleciona o registro que deseja-se excluir e deleta-o}
      consulta(' where id_consulta = ' + edtId.Text);
      dm.cds1.Delete;
      dm.cds1.ApplyUpdates(-1);
      desabilitarComponentes;

      messageDlg('Registro deletado com sucesso', mtInformation, [mbOk], 0);

      {trata excesso no cdigo acima - em caso de erro passa aki}      
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfConsulta.btnAlterarClick(Sender: TObject);
begin
   {executa uma consulta pegando o registro que deseja-se alterar}
   consulta(' where id_consulta = ' + edtId.Text);
   {altera os valore do registro no componente e salva no banco}
   gravarRegistro;

end;

procedure TfConsulta.btnDeletarClick(Sender: TObject);
begin
   deletaRegistro;
end;

procedure TfConsulta.BitBtn4Click(Sender: TObject);
var
   frm: TfInternacao;
begin

   try
      frm:= TfInternacao.Create(application);
      frm.edtCodConsulta.Text:= edtId.Text;
      frm.habilitaDesabilitaBotao(true, false, false, true, false, false);
      frm.ShowModal;

      finally
         frm.free;
   end;
end;

end.
