unit uDm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uAbertura, DBXpress, FMTBcd, DB, SqlExpr, uLookupSemBde,
  Provider, DBClient, shellApi;

type
  Tdm = class(TDataModule)
    con: TSQLConnection;
    q1: TSQLQuery;
    cds1: TClientDataSet;
    ds1: TDataSetProvider;
    sql1: TSQLDataSet;
    sqlGenerator: TSQLDataSet;
    cdsGenerator: TClientDataSet;
    dsgenerator: TDataSetProvider;
    sqlAux: TSQLDataSet;
    cdsAux: TClientDataSet;
    dsAux: TDataSetProvider;
    dsrelatorios: TDataSource;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { Private declarations }
    vversao: string;
    vendarquivo: string;
    vbancoDeDados: string;
    vusuario: string;
    vsenha: string;
    venderecoHelp: string;

  public
    { Public declarations }
     frmAbertura: tfAbertura;

     property versao: string read vversao write vversao;
     property arquivoConfig: string read vendarquivo write vendarquivo;
     property bancoDeDados: string read vbancoDeDados write vbancoDeDados;
     property usuario: string read vusuario write vusuario;
     property senha: string read vsenha write vsenha;
     property enderecoHelp: string read venderecoHelp write venderecoHelp;

     function getGenerator(generator: string): string;
     procedure consulta(campos, tabela, where: string);
     function ajustarFloat(valor: string): string;
     procedure ExecutarPrograma(Nome, Parametros: String);
     function convertToDate(valor: String): boolean;

  end;

var
  dm: Tdm;
  lkp: fLookUp;

implementation



{$R *.dfm}

procedure Tdm.DataModuleCreate(Sender: TObject);
begin

   {Define a verso do aplicativo}
   versao:= 'Hospital 1.0 (beta)';

   {cria a string list que ira conter o endereco do banco de dados}
   arquivoConfig:= ExtractFilePath(application.ExeName) + 'dados\Hospital.gdb';
   enderecoHelp:= ExtractFilePath(Application.ExeName) + 'help\help.hlp';

   Application.HelpFile:= enderecoHelp;

   if not FileExists(arquivoConfig) then
   begin
      MessageDlg('O banco de dados no se encontra na pasta ' + arquivoConfig, mtError, [mbOk], 0);
      Application.Terminate;
   end
   else
      bancoDeDados:= arquivoConfig;

   {abrindo a janela de senha}
   frmAbertura:= tfAbertura.Create(application);
   try
      frmAbertura.ShowModal;
      finally
         frmAbertura.free;
   end;

   lkp:= fLookUp.create;
   with lkp do
   begin
      User:= usuario;
      Password:= senha;
      Database:= bancoDeDados;
      connect;
   end;
end;

function Tdm.getGenerator(generator: string): string;
begin

   try
      dm.cdsGenerator.Close;
      dm.sqlGenerator.CommandText:= 'select gen_id(' + generator + ', 1) as gen from rdb$database';
      dm.cdsGenerator.Open;
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;

   result:= intToStr(dm.cdsGenerator.fieldbyName('gen').asInteger);

end;

procedure Tdm.DataModuleDestroy(Sender: TObject);
begin
   lkp.Free;
end;

procedure Tdm.consulta(campos, tabela, where: string);
begin

   try
      dm.cdsAux.Close;
      dm.sqlAux.CommandText:= 'select ' + campos + ' from ' + tabela + where;
      dm.cdsAux.Open;
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

function tdm.ajustarFloat(valor: string): string;
begin

   try
      result:= formatFloat('##0.00', strToFloat(valor));
      except
         result:= '0,00';
   end;
end;


{funo para abrir arquivos externos - usa shellApi}
procedure tDm.ExecutarPrograma(Nome, Parametros: String);
Var
   Comando: Array[0..1024] of Char;
   Parms: Array[0..1024] of Char;
begin
   StrPCopy (Comando, Nome);
   StrPCopy (Parms, Parametros);
   ShellExecute (0, Nil, Comando, Parms, pChar(extractFilePath(nome)), SW_Normal);
end;

{Converte data para ver se corresponde a um valor vlido}
function tDm.convertToDate(valor: String): boolean;
var
   data: tDateTime;
begin
   result:= true;
   try
      data:= StrToDate(valor);
      except
         result:= false;
   end
end;

end.
