unit uEspecialidade;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TfEspecialidades = class(TForm)
    btnnovo: TBitBtn;
    btnAlterar: TBitBtn;
    btnDeletar: TBitBtn;
    btnSalvar: TBitBtn;
    btnSair: TBitBtn;
    Panel1: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edtNomeEspecialidade: TEdit;
    edtCodEspecialidade: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnnovoClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
    procedure desabilitarComponentes;
    procedure habilitarComponentes;
    procedure habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
    procedure gravarRegistro;
    procedure consulta(where: string);
    procedure deletaRegistro;
    
  end;

var
  fEspecialidades: TfEspecialidades;

implementation

uses uDm, DBClient, DB;

{$R *.dfm}

procedure TfEspecialidades.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {limpa o form da memoria e seta a varivel para nil}
   Action:= cafree;
   fEspecialidades:= nil;
end;


procedure TfEspecialidades.habilitarComponentes;
var
   i: integer;
begin

   {varre os componentes da tela e habilita os edits e comboBox}
   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= true;
         (Components[i] as tEdit).Color:= clWindow;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= true;
         (Components[i] as TComboBox).Color:= clWindow;
      end;
   end;

   {muda a cor do edit codespecialidade - componente e font}
   edtCodEspecialidade.Color:= $007a513d;
   edtCodEspecialidade.Font.Color:= clWhite;
end;

procedure TfEspecialidades.desabilitarComponentes;
var
   i: integer;
begin
   {varre os componentes da tela e desabilita os edits e comboBox}
   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= false;
         (Components[i] as tEdit).clear;
         (Components[i] as tEdit).Color:= clMedGray;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= false;
         (Components[i] as TComboBox).ItemIndex:= -1;
         (Components[i] as TComboBox).Color:= clMedGray;
      end
   end;
end;

procedure TfEspecialidades.FormCreate(Sender: TObject);
begin
   {cria o form desabilitando alguns componentes e habilitando alguns botes}
   desabilitarComponentes;
   habilitaDesabilitaBotao(true, false, false, false);
end;

procedure TfEspecialidades.btnnovoClick(Sender: TObject);
begin
   {habilita alguns componentes e desabilitando alguns botes}
   habilitaDesabilitaBotao(false, false, false, true);
   habilitarComponentes;

   {executa uma consulta para criar no compenente a estrutura necessria para a insero}
   consulta('');

   {pega o valor generator do banco}
   edtCodEspecialidade.Text:= dm.getGenerator('gen_especialidade');

   {gera um registro novo no componente}
   dm.cds1.Insert;
   edtNomeEspecialidade.SetFocus;
end;

procedure TfEspecialidades.btnSairClick(Sender: TObject);
begin
   close;
end;

procedure TfEspecialidades.habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
begin
   {habilita ou desabilita os componentes da tela}
   btnnovo.enabled:= Novo;
   btnDeletar.enabled:= deletar;
   btnAlterar.enabled:= alterar;
   btnSalvar.enabled:= salvar;
end;

procedure TfEspecialidades.btnSalvarClick(Sender: TObject);
begin

   if edtNomeEspecialidade.Text = '' then
   begin
      messageDlg('Nome especialidade  um campo obrigatrio', mtInformation, [mbOk], 0);
      abort;
   end;

   try
      {chama a procedure para salvar os dados no banco de dados}
      gravarRegistro;
      messageDlg('Registro salvo com sucesso', mtInformation, [mbOk], 0);

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on e:exception do
         messageDlg(e.message, mtError, [mbOk], 0);
   end;

   {trata os componentes da tela}
   habilitaDesabilitaBotao(true, false, false, false);
   desabilitarComponentes;
end;

procedure TfEspecialidades.btnAlterarClick(Sender: TObject);
begin

   {executa uma consulta pegando o registro que deseja-se alterar}
   consulta(' where id_especialidade = ' + edtCodEspecialidade.Text);
   {altera os valore do registro no componente e salva no banco}
   gravarRegistro;
end;

procedure TfEspecialidades.gravarRegistro;
begin

   {se o clientDataset estiver inativo gera uma execption}
   if not dm.cds1.Active then
      raise Exception.Create('Execute uma consulta antes');

   {modifica os registros no clientDataSet e salva banco atraves do applyUpdates}
   try
      with dm.cds1 do
      begin
         {coloca o componente em modo de edio}
         Edit;

         {atualiza os valores dos campos no componente}
         FieldByName('id_especialidade').AsInteger:= strToInt(edtCodEspecialidade.Text);
         FieldByName('especialidade').asString:= edtNomeEspecialidade.Text;

         {escreve a modificao no registro}
         Post;

         {aplica as atualizaes no banco de dados}
         ApplyUpdates(-1);
      end;

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on  e: exception do
         messageDlg('No foi possvel salvar registro' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfEspecialidades.consulta(where: string);
begin

   try
      {executa uma consulta no componente}
      dm.cds1.Close;
      dm.sql1.CommandText:= 'select * from especialidade ' + where;
      dm.cds1.Open;

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfEspecialidades.deletaRegistro;
begin

   try
      {seleciona o registro que deseja-se excluir e deleta-o}
      consulta(' where id_especialidade = ' + edtCodEspecialidade.Text);
      dm.cds1.Delete;
      dm.cds1.ApplyUpdates(-1);
      desabilitarComponentes;

      messageDlg('Registro deletado com sucesso', mtInformation, [mbOk], 0);

      {trata excesso no cdigo acima - em caso de erro passa aki}      
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfEspecialidades.btnDeletarClick(Sender: TObject);
begin
   deletaRegistro;
end;

end.
