unit uInternacao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Mask;

type
  TfInternacao = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    btnnovo: TBitBtn;
    btnAlterar: TBitBtn;
    btnDeletar: TBitBtn;
    BitBtn3: TBitBtn;
    btnSalvar: TBitBtn;
    GroupBox1: TGroupBox;
    edtCodInternacao: TEdit;
    Label1: TLabel;
    edtDataInternacao: TMaskEdit;
    Label3: TLabel;
    Label2: TLabel;
    edtCodConsulta: TEdit;
    Label4: TLabel;
    edtCodLeito: TEdit;
    edtSetor: TEdit;
    btnPesqLeito: TBitBtn;
    edtDataAlta: TMaskEdit;
    Label5: TLabel;
    edtLeito: TEdit;
    btnPesqPaciente: TBitBtn;
    Label9: TLabel;
    Label10: TLabel;
    edtPaciente: TEdit;
    Label8: TLabel;
    procedure btnnovoClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnPesqLeitoClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnPesqPacienteClick(Sender: TObject);
  private
    { Private declarations }
    procedure gravarRegistro;
    procedure consulta(where: string);
    procedure deletaRegistro;
    procedure pesquisaLookup(tabela: string; var param1, param2, param3: string);

  public
    { Public declarations }
    procedure desabilitarComponentes;
    procedure habilitarComponentes;
    procedure habilitaDesabilitaBotao(novo, alterar, deletar, salvar, leito, paciente: boolean);
        
  end;

var
  fInternacao: TfInternacao;

implementation

uses uDm, uPesquisas;

{$R *.dfm}



procedure TfInternacao.habilitarComponentes;
var
   i: integer;
begin

   {varre os componentes da tela e habilita os edits e comboBox}
   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= true;
         (Components[i] as tEdit).Color:= clWindow;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= true;
         (Components[i] as TComboBox).Color:= clWindow;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= true;
         (Components[i] as TMaskEdit).Color:= clWindow;
      end;
   end;

   {muda a cor do edit codespecialidade - componente e font}
   edtCodInternacao.Color:= $007a513d;
   edtCodConsulta.Color:= $007a513d;
   edtCodLeito.Color:= $007a513d;

end;

procedure TfInternacao.desabilitarComponentes;
var
   i: integer;
begin
   {varre os componentes da tela e desabilita os edits e comboBox}
   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= false;
         (Components[i] as tEdit).clear;         
         (Components[i] as tEdit).Color:= clMedGray;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= false;
         (Components[i] as TComboBox).ItemIndex:= -1;
         (Components[i] as TComboBox).Color:= clMedGray;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= false;
         (Components[i] as TMaskEdit).clear;
         (Components[i] as TMaskEdit).Color:= clMedGray;
      end;
   end;
end;



procedure TfInternacao.gravarRegistro;
begin

   {se o clientDataset estiver inativo gera uma execption}
   if not dm.cds1.Active then
      raise Exception.Create('Execute uma consulta antes');

   {modifica os registros no clientDataSet e salva banco atraves do applyUpdates}
   try
      with dm.cds1 do
      begin
         {coloca o componente em modo de edio}
         Edit;

         {atualiza os valores dos campos no componente}
         FieldByName('id_internacao').asInteger  := strToInt(edtCodInternacao.Text);
         FieldByName('id_consulta').asInteger    := strToInt(edtCodConsulta.Text);
         FieldByName('data').asDateTime          := strToDate(edtDataInternacao.Text);
         FieldByName('id_leito').asInteger       := strToInt(edtCodLeito.Text);

         if (not dm.convertToDate(edtDataAlta.Text)) then
            FieldByName('dataAlta').asDateTime      := null
         else
            FieldByName('dataAlta').asDateTime      := strToDate(edtDataAlta.Text);

         {escreve a modificao no registro}
         Post;

         {aplica as atualizaes no banco de dados}
         ApplyUpdates(-1);
      end;

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on  e: exception do
         messageDlg('No foi possvel salvar registro' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfInternacao.consulta(where: string);
begin

   try
      {executa uma consulta no componente}
      dm.cds1.Close;
      dm.sql1.CommandText:= 'select * from internacao ' + where;
      dm.cds1.Open;

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfInternacao.deletaRegistro;
begin

   try
      {seleciona o registro que deseja-se excluir e deleta-o}
      consulta(' where id_internacao = ' + edtCodInternacao.Text);
      dm.cds1.Delete;
      dm.cds1.ApplyUpdates(-1);
      desabilitarComponentes;

      messageDlg('Registro deletado com sucesso', mtInformation, [mbOk], 0);

      {trata excesso no cdigo acima - em caso de erro passa aki}      
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfInternacao.habilitaDesabilitaBotao(novo, alterar, deletar, salvar, leito, paciente: boolean);
begin
   {habilita ou desabilita os componentes da tela}
   btnnovo.enabled:= Novo;
   btnDeletar.enabled:= deletar;
   btnAlterar.enabled:= alterar;
   btnSalvar.enabled:= salvar;
   btnPesqLeito.enabled:= leito;
   btnPesqPaciente.enabled:= paciente;
end;


procedure TfInternacao.btnnovoClick(Sender: TObject);
begin
   {habilita alguns componentes e desabilitando alguns botes}
   habilitaDesabilitaBotao(false, false, false, true, true, true);
   habilitarComponentes;

   {executa uma consulta para criar no compenente a estrutura necessria para a insero}
   consulta('');

   {pega o valor generator do banco}
   edtCodInternacao.Text:= dm.getGenerator('gen_internacao');

   {gera um registro novo no componente}
   dm.cds1.Insert;
   edtDataInternacao.SetFocus;
end;

procedure TfInternacao.btnAlterarClick(Sender: TObject);
begin

   {executa uma consulta pegando o registro que deseja-se alterar}
   consulta(' where id_internacao = ' + edtCodInternacao.Text);
   {altera os valore do registro no componente e salva no banco}
   gravarRegistro;
end;

procedure TfInternacao.btnDeletarClick(Sender: TObject);
begin
   deletaRegistro;
end;

procedure TfInternacao.btnSalvarClick(Sender: TObject);
begin

   if (edtCodConsulta.Text = '') or
         (edtCodLeito.Text = '') or
         (edtDataInternacao.Text = '') then
   begin
      messageDlg('Os campos CodConsulta, CodLeito e Data da Internao so obrigatrios, preencha-os antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   if (not dm.convertToDate(edtDataInternacao.Text)) then
   begin
      messageDlg('Existe um valor invlido para campo data, corrja-o antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   try
      {chama a procedure para salvar os dados no banco de dados}
      gravarRegistro;
      messageDlg('Registro salvo com sucesso', mtInformation, [mbOk], 0);

      {trata excesso no cdigo acima - em caso de erro passa aki}
      except on e:exception do
         messageDlg(e.message, mtError, [mbOk], 0);
   end;

   {trata os componentes da tela}
   habilitaDesabilitaBotao(true, false, false, false, false, false);
   desabilitarComponentes;
end;

procedure TfInternacao.btnPesqLeitoClick(Sender: TObject);
var
   vCod, vSetor, vLeito: string;
begin
   pesquisaLookup('leito', vCod, vSetor, vLeito);
   edtCodLeito.Text:= vcod;
   edtSetor.Text:= vSetor;
   edtLeito.Text:= vLeito;
end;


procedure TfInternacao.pesquisaLookup(tabela: string; var param1, param2, param3: string);
var
   frm: TfPesquisas;
begin

   try
      frm:= TfPesquisas.Create(application);

      with frm do
      begin
         cbParametroPesquisa.ItemIndex:= frm.cbParametroPesquisa.Items.IndexOf(tabela);
         cbParametroPesquisaChange(nil);
         cbParametroPesquisa.Enabled:= false;
         btnsair.Caption:= 'Selecionar';
         btnSair.Glyph:= frm.btnOk.Glyph;
         ShowModal;
      end;

      if frm.lvResult.Selected <> nil then
      begin
         param1:= frm.lvResult.Selected.Caption;
         param2:= frm.lvResult.Selected.SubItems[0];
         param3:= frm.lvResult.Selected.SubItems[1];
      end;

      finally
         frm.Free;
   end;
end;

procedure TfInternacao.BitBtn3Click(Sender: TObject);
begin
   close;
end;

procedure TfInternacao.FormCreate(Sender: TObject);
begin
   desabilitarComponentes;
   habilitaDesabilitaBotao(true, false, false, false, false, false);
end;

procedure TfInternacao.btnPesqPacienteClick(Sender: TObject);
var
   vCod, vpaciente, vdata: string;
begin
   pesquisaLookup('Internacao', vCod, vpaciente, vdata);
   edtCodConsulta.Text:= vcod;
   edtPaciente.Text:= vpaciente;
end;


end.
