{**************************************************************************}
{                                                                          }
{     Fabrcio Souza Costa  e jonas henrique                               }
{     Estudo de Classe                                                     }
{     faz uma conexo com o banco de dados                                 }
{                                                                          }
{**************************************************************************}

(* campo memo

   with lkp do
   begin
      FieldKey:= 'seqDadosTecnicos';
      Field:= 'dadoTecnico';
      FieldComplementar:= 'cast('''' as varchar(200)) as descricao, descricao as memo';
      Table:= 'dadosTecnicos';
      OrderBy:= 'dadoTecnico';
      execLookup;
   end;
*)

unit uLookupSemBde;


interface


uses
   sysUtils, DB, IBDatabase, IBCustomDataSet, IBQuery, forms, dialogs,
   DbTables, dbGrids, graphics, controls,
   Windows, Messages, Classes, ComCtrls, ExtCtrls, Menus, StdCtrls, ToolWin, mMSystem,
   DBCtrls, ScktComp, IBUpdateSQL;







{*************************************************************************}
{}
{        classe conexao}
{}
{*************************************************************************}
type
   fConexao = class

      private
         {variveis privadas}
         tQ1: TIBQuery;
         tIbdb1: TIBDatabase;
         tIbt1: TIBTransaction;
         tUp1: TIBUpdateSQL;

         sDatabase: string;
         sUser: string;
         sPas: string;
         sArquivo: string;

      protected
         {mtodos}
         function fcDateTimeServidor(strDateOuTime: string): string; virtual;
         constructor create; virtual;
         destructor destroy; virtual;

      public
         {properties}
         property Database: string read sDatabase write sDatabase;
         property User: string read sUser write sUser;
         property Password: string read sPas write sPas;
         property Arquivo: string read sArquivo;

         {mtodos}
         procedure connect;
   end;





{*************************************************************************}
{}
{        classe tLockup}
{}
{*************************************************************************}

// clasee tLockup
type
   fLookUp = class(fConexao)

      private
         vFieldKey: string;
         vField: string;
         vFieldComp: string;         
         vTable: string;
         vAnd: string;
         vOrderBy: string;
         vText: string;
         vComp: string;

         frm: tform;
         ds1: TDataSource;
         dbg1: tdbGrid;
         pnBottom: tPanel;
         pnClient: tPanel;

         procedure setOrderBy(const Value: string);

      protected
         procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);

      {mtodos get and set}
      public
         {properties}
         property FieldKey: string read vFieldKey write vFieldKey;
         property Field: string read vField write vField;
         property FieldComplementar: string read vFieldComp write vFieldComp;
         property Complemento: string read vComp write vComp;
         property Table: string read vTable write vTable;
         property AndSql: string read vAnd write vAnd;
         property OrderBy: string read vOrderBy write setOrderBy;
         property TextComparativo: string read vText write vText;

         {constructor e destructor}
         constructor create; override;
         destructor destroy; override;

         {mtodos}
         procedure execLookup();
         procedure execKey();

   end;

implementation

uses DateUtils;



{*************************************************************************}
{}
{        classe conexao}
{}
{*************************************************************************}


{ classe pai fcConexao}

procedure fConexao.connect;
begin

   with tIbdb1 do
   begin
      Params.Add('user_name=' + User);
      Params.add('password=' + Password);
      DatabaseName:= Database;
      LoginPrompt:= false;
      DefaultTransaction:= tIbt1;
   end;

   with tUp1 do
      ModifySQL.Add('somente para manipulacao do blob ou memo');

   with tQ1 do
   begin
      Database:= tIbdb1;
      Transaction:= tIbt1;
      CachedUpdates:= true;
      UpdateObject:= tUp1;
   end;

   try
      tIbdb1.Connected:= true;
      except on e: exception do
         showMessage(e.Message);
   end;
end;


{ classe pai fcDateTimeServidor}
function fConexao.fcDateTimeServidor(strDateOuTime: string): string;
begin
   try
      connect;

      with tQ1 do
      begin
         close;
         sql.clear;
         sql.add(' select current_Timestamp as DataEHora from rdb$database ');
         open;
      end;

      if lowerCase(strDateOuTime) = 'date' then
         result:= formatDateTime('dd/mm/yyyy', tQ1.fieldByName('DataEHora').asDateTime)
      else if lowerCase(strDateOuTime) = 'time' then
         result:= formatDateTime('hh:mm:ss', tQ1.fieldByName('DataEHora').asDateTime);

      except
         showMessage('Erro ao Conectar GDB');
   end;
end;


{ classe pai constructor }
constructor fConexao.create;
begin
   tQ1:= TIBQuery.create(application);
   tIbdb1:= TIBDatabase.create(application);
   tIbt1:= TIBTransaction.Create(application);
   tUp1:= TIBUpdateSQL.Create(application);
end;

{ classe pai destructor }
destructor fConexao.destroy;
begin
   tQ1.free;
   tIbdb1.free;
   tIbt1.free;
   tUp1.Free;
end;






{*************************************************************************}
{}
{        classe lockUp}
{}
{*************************************************************************}


{faz uma consulta lockUp e retorna o os fields passados na propriedade}
procedure fLookUp.execLookup();
var
   ClicouOK: Boolean;
   textResult: string;
   i, indice: integer;
begin

   textResult:= '';
   ClicouOK:= InputQuery('Digite o nome que deseja localizar', 'Digite o nome que deseja localizar :', textResult);
   if ClicouOK then
   begin
      TextComparativo:= textResult;

      with frm do
      begin
         Width:= 500;
         Height:= 300;
         Caption:= 'Resultado de Pesquisa';
         Position:= poScreenCenter;
      end;

      with ds1 do
         DataSet:= tQ1;

      with pnClient do
      begin
         align:= alClient;
         Caption:= '';
         BevelInner:= bvRaised;
         BevelOuter:= bvLowered;
         Height:= 30;
         Visible:= true;
         parent:= frm;
      end;

      with dbg1 do
      begin
         align:= alClient;
         BorderStyle:= bsNone;
         DataSource:= ds1;
         Font.Color:= clNavy;
         ReadOnly:= True;
         TabOrder:= 0;
         OnKeyPress:= DBGrid1KeyPress;
         parent:= pnClient;
      end;

      with pnBottom do
      begin
         align:= alBottom;
         BevelInner:= bvNone;
         BevelOuter:= bvNone;
         Alignment:= taRightJustify;
         Caption:= 'Pesquisa Lookup - Selecione o registro desejado ...   ';
         Font.Color:= $007A513D;
         Height:= 25;
         Visible:= true;
         parent:= frm;
      end;

      if not tIbt1.InTransaction then
         tIbt1.StartTransaction;

      tIbt1.Commit;


      with tQ1 do
      begin
         close;
         sql.clear;
         sql.add('select ' + FieldKey + ',' + Field );

         if (FieldComplementar <> '') then
            sql.add(', ' + FieldComplementar );

         sql.add(' from ' + Table );
         sql.add(' where ');
         sql.add('upper(' + Field + ') like ''%' + upperCase(trim(TextComparativo)) + '%'' ');
         sql.add(AndSql);
         
         if (OrderBy <> '') and (OrderBy <> ' order by ') then
            sql.add(' ' + OrderBy);

         open;
      end;

      // se tiver campo complentar do tipo blob trata-o aki
      if (FieldComplementar <> '') then
      begin
         indice:= 0;
         for i:= 0 to tQ1.FieldCount -1 do
         begin
            if (tQ1.Fields[i].DataType = ftMemo) or
               (tQ1.Fields[i].DataType = ftBlob) then
            begin
               indice:= i;
               break;
            end;
         end;

         if (indice <> 0) then
         begin
            while not tQ1.eof do
            begin
               if not tQ1.fields[indice].IsNull then
               begin
                  tQ1.edit;
                  tQ1.fields[indice - 1].asString:= tQ1.fields[indice].AsString;
                  tQ1.Next;
               end;
            end;
         end;
      end;

//      SetForegroundWindow(frm.Handle);
      frm.ShowModal;

      Field:= tQ1.fieldByName(Field).asString;
      FieldKey:= tQ1.fieldByName(FieldKey).asString;

      if FieldComplementar <> '' then
         Complemento:= tQ1.fieldByName(FieldComplementar).asString;

      OrderBy:= '';
      AndSql:= '';
      TextComparativo:= '';
      FieldComplementar:= '';
   end
   else
      raise Exception.create('');

end;

procedure fLookUp.execKey();
begin

   with tQ1 do
   begin
      close;
      sql.clear;
      sql.add('select ' + FieldKey + ',' + Field );

      if (FieldComplementar <> '') then
         sql.add(', ' + FieldComplementar );


      sql.add(' from ' + Table );
      sql.add(' where upper(' + FieldKey + ') = :parametro');
      paramByName('parametro').asString:= upperCase(TextComparativo);
      open;
   end;

   Field:= tQ1.fieldByName(Field).asString;
   FieldKey:= tQ1.fieldByName(FieldKey).asString;

   if FieldComplementar <> '' then
      Complemento:= tQ1.fieldByName(FieldComplementar).asString;

   OrderBy:= '';
   AndSql:= '';
   TextComparativo:= '';
   FieldComplementar:= '';
  
end;

{ classe filha destructor // herdeira de tConexao.create }
constructor fLookUp.create;
begin
   inherited;
   frm:= tForm.Create(nil);
   ds1:= TDataSource.Create(frm);
   dbg1:= TDBGrid.Create(frm);
   pnBottom:= TPanel.Create(frm);
   pnClient:= TPanel.Create(frm);
end;


{ classe filha destructor // herdeira de tConexao.destroy }
destructor fLookUp.destroy;
begin
   inherited;
   frm.free;
   ds1.free;
   dbg1.free;
   pnBottom.free;
   pnClient.free;
end;

procedure fLookUp.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then
      frm.close;
end;



procedure fLookUp.setOrderBy(const Value: string);
begin
   vOrderBy:= ' order by ' + Value;
end;

end.
