unit uPacientes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TfPacientes = class(TForm)
    GroupBox1: TGroupBox;
    lblNome: TLabel;
    lblCodigo: TLabel;
    lblRua: TLabel;
    lblBairro: TLabel;
    lblCidade: TLabel;
    edtNomePaciente: TEdit;
    edtCodPaciente: TEdit;
    edtBairro: TEdit;
    btnSair: TBitBtn;
    Panel1: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    edtRua: TEdit;
    lblNumero: TLabel;
    edtNumero: TEdit;
    edtComplemento: TEdit;
    lblComplemento: TLabel;
    edtCidade: TEdit;
    cbUF: TComboBox;
    lblUF: TLabel;
    lblCPF: TLabel;
    lblEmail: TLabel;
    edtNomeMae: TEdit;
    medtCPF: TMaskEdit;
    lblNomeMae: TLabel;
    edtEmail: TEdit;
    cbSexo: TComboBox;
    lblSexo: TLabel;
    meditDataCadastro: TMaskEdit;
    lblDataCadastro: TLabel;
    medtDataNascimento: TMaskEdit;
    lblDataNascimento: TLabel;
    lblTelefone: TLabel;
    medtTelefone: TMaskEdit;
    lblCelular: TLabel;
    medtCelular: TMaskEdit;
    btnSalvar: TBitBtn;
    btnDeletar: TBitBtn;
    btnAlterar: TBitBtn;
    btnNovo: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
  private
    { Private declarations }


  public
    { Public declarations }
    procedure desabilitarComponentes;
    procedure habilitarComponentes;
    procedure habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
    procedure gravarRegistro;
    procedure consulta(where: string);
    procedure deletaRegistro;
   
  end;

var
  fPacientes: TfPacientes;

implementation

uses uDm;

{$R *.dfm}

procedure TfPacientes.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action:= cafree;
   fPacientes:= nil;
end;


procedure TfPacientes.habilitarComponentes;
var
   i: integer;
begin

   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= true;
         (Components[i] as tEdit).Color:= clWindow;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= true;
         (Components[i] as TComboBox).Color:= clWindow;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= true;
         (Components[i] as TMaskEdit).Color:= clWindow;
      end;
   end;

   edtCodPaciente.Color:= $007a513d;
   edtCodPaciente.Font.Color:= clWhite;
   meditDataCadastro.Text:= dateToStr(date);
   cbSexo.ItemIndex:= 0;
end;

procedure TfPacientes.desabilitarComponentes;
var
   i: integer;
begin

   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= false;
         (Components[i] as tEdit).clear;
         (Components[i] as tEdit).Color:= clMedGray;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= false;
         (Components[i] as TComboBox).ItemIndex:= -1;
         (Components[i] as TComboBox).Color:= clMedGray;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= false;
         (Components[i] as TMaskEdit).clear;
         (Components[i] as TMaskEdit).Color:= clMedGray;
      end;
   end;   
end;

procedure TfPacientes.FormCreate(Sender: TObject);
begin
   desabilitarComponentes;
   habilitaDesabilitaBotao(true, false, false, false);   
end;

procedure TfPacientes.btnSairClick(Sender: TObject);
begin
   close;
end;

procedure TfPacientes.BitBtn3Click(Sender: TObject);
begin
   habilitarComponentes;
   edtNomePaciente.SetFocus;
end;

procedure TfPacientes.habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
begin
   btnnovo.enabled:= Novo;
   btnDeletar.enabled:= deletar;
   btnAlterar.enabled:= alterar;
   btnSalvar.enabled:= salvar;
end;


procedure TfPacientes.btnNovoClick(Sender: TObject);
begin
   habilitaDesabilitaBotao(false, false, false, true);
   habilitarComponentes;

   consulta('');

   edtCodPaciente.Text:= dm.getGenerator('gen_paciente');
   dm.cds1.Insert;
   edtNomePaciente.SetFocus;   
end;

procedure TfPacientes.btnSalvarClick(Sender: TObject);
begin

   if (edtNomePaciente.Text = '') or
           (trim(meditDataCadastro.Text) = '/  /') or
           (trim(medtDataNascimento.Text) = '/  /') then
   begin
      messageDlg('O nome do paciente, data de cadastro e data de nascimento so campos obrigatrios, preencha-o antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   if (not dm.convertToDate(meditDataCadastro.Text)) or
           (not dm.convertToDate(medtDataNascimento.Text))  then
   begin
      messageDlg('Existe um valor invlido para campo data, corrja-o antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   try
      gravarRegistro;
      messageDlg('Registro salvo com sucesso', mtInformation, [mbOk], 0);
      except on e:exception do
         messageDlg(e.message, mtError, [mbOk], 0);
   end;

   habilitaDesabilitaBotao(true, false, false, false);
   desabilitarComponentes;
end;

procedure TfPacientes.gravarRegistro;
begin
   if not dm.cds1.Active then
      raise Exception.Create('Execute uma consulta antes');

   try
      with dm.cds1 do
      begin
         Edit;
         FieldByName('id_paciente').AsInteger:= strToInt(edtCodPaciente.Text);
         FieldByName('nome').asString:= edtNomePaciente.Text;
         FieldByName('sexo').asString:= cbSexo.Text;
         FieldByName('logradouro').asString:= edtRua.Text;
         FieldByName('complemento').asString:= edtComplemento.Text;         
         FieldByName('numero').asString:= edtNumero.Text;
         FieldByName('bairro').asString:= edtBairro.Text;
         FieldByName('cidade').asString:= edtCidade.Text;
         FieldByName('uf').asString:= cbUF.Text;
         FieldByName('dataentrada').AsDateTime:= strToDate(meditDataCadastro.Text);
         FieldByName('datanascimento').AsDateTime:= strToDate(medtDataNascimento.Text);
         FieldByName('telefone').asString:= medtTelefone.Text;
         FieldByName('celular').asString:= medtCelular.Text;
         FieldByName('cpf').asString:= medtCPF.Text;
         FieldByName('nomemae').asString:= edtNomeMae.Text;
         FieldByName('email').asString:= edtEmail.Text;
         Post;
         ApplyUpdates(-1);
      end;
      except on  e: exception do
         messageDlg('No foi possvel salvar registro' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfPacientes.consulta(where: string);
begin

   try
      dm.cds1.Close;
      dm.sql1.CommandText:= 'select * from paciente ' + where;
      dm.cds1.Open;
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfPacientes.deletaRegistro;
begin

   try
      consulta(' where id_paciente = ' + edtCodPaciente.Text);
      dm.cds1.Delete;
      dm.cds1.ApplyUpdates(-1);
      desabilitarComponentes;

      messageDlg('Registro deletado com sucesso', mtInformation, [mbOk], 0);

      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfPacientes.btnAlterarClick(Sender: TObject);
begin
   consulta(' where id_paciente = ' + edtCodPaciente.Text);
   gravarRegistro;
end;

procedure TfPacientes.btnDeletarClick(Sender: TObject);
begin
   deletaRegistro;
end;

end.
