unit uPesquisas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, Buttons, ImgList, Menus;

type
  TfPesquisas = class(TForm)
    btnSair: TBitBtn;
    Panel5: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    ImageList1: TImageList;
    cbParametroPesquisa: TComboBox;
    btnPesquisar: TBitBtn;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    edtFiltro: TEdit;
    cbFiltro: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Panel6: TPanel;
    lvResult: TListView;
    Panel1: TPanel;
    pp1: TPopupMenu;
    AlterarRegistro1: TMenuItem;
    ExcluirRegistro1: TMenuItem;
    btnOk: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSairClick(Sender: TObject);
    procedure btnPesquisarClick(Sender: TObject);
    procedure lvResultDblClick(Sender: TObject);
    procedure cbParametroPesquisaChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure AlterarRegistro1Click(Sender: TObject);
    procedure ExcluirRegistro1Click(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
    
  end;


var
  fPesquisas: TfPesquisas;

implementation

uses uDm, DB, uLaitos, uCadMedico, uRemedios, uEspecialidade, uPacientes,
  uConsulta, SqlExpr, uInternacao;

{$R *.dfm}

procedure TfPesquisas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action:= cafree;
   fPesquisas:= nil;
end;

procedure TfPesquisas.btnSairClick(Sender: TObject);
begin
   close;
end;

procedure TfPesquisas.btnPesquisarClick(Sender: TObject);
var
   coluna: integer;
   it: TListItem;
   cl: TListColumn;
begin

   if (cbParametroPesquisa.ItemIndex = -1) then
      abort;

   lvResult.Clear;
   for coluna:= lvResult.Columns.Count -1 downto 0 do
      lvResult.Columns.Delete(coluna);

   try

     with dm.q1 do
     begin
        close;
        sql.clear;

        if cbParametroPesquisa.Text = 'Consulta' then
        begin
           sql.add('select c.id_consulta, c.tipoConsulta, c.id_medico, m.medico,       ');
           sql.add(' c.id_paciente, p.nome, c.dataconsulta, c.observacao               ');
           sql.add(' from consulta c                                                   ');
           sql.add(' join medico m on (m.id_medico = c.id_medico)                      ');
           sql.add(' join paciente p on (p.id_paciente = c.id_paciente)                ');
        end
        else if cbParametroPesquisa.Text = 'Internacao' then
        begin
           sql.add('select  i.id_internacao, p.nome, m.medico, i.id_consulta,          ');
           sql.add(' i.data, i.dataAlta, i.id_leito, l.setor, l.leito                  ');
           sql.add(' from internacao i                                                 ');
           sql.add(' join leito l on (l.id_leito = i.id_leito)                         ');
           sql.add(' join consulta c on (c.id_consulta = i.id_consulta)                ');
           sql.add(' join paciente p on (p.id_paciente = c.id_paciente)                ');
           sql.add(' join medico m on (m.id_medico = c.id_medico)                      ');
        end
        else
        begin
           sql.add('select *                                                      ');
           sql.add('  from ' + cbParametroPesquisa.Text                            );
        end;

        if (edtFiltro.text <> '') and (cbFiltro.ItemIndex >= 0) then
           sql.add('  where upper(' + cbFiltro.Text + ') like upper(''%' + edtFiltro.Text + '%'')');

        open;
     end;


     for coluna:= 0 to dm.q1.FieldCount -1 do
     begin
        cl:= lvResult.Columns.add;
        cl.Caption:= dm.q1.Fields[coluna].FieldName;
        cl.Width:= 100;
     end;

     while not dm.q1.Eof do
     begin

        it:= lvResult.Items.Add;
        it.Caption:= dm.q1.FieldByName(dm.q1.Fields[0].FieldName).AsString;

        for coluna:= 1 to dm.q1.FieldCount -1 do
           it.SubItems.Add(dm.q1.FieldByName(dm.q1.Fields[coluna].FieldName).AsString);

        dm.q1.Next;

     end;
     except on e: exception do
        messagedlg(e.Message, mtError, [mbok], 0);
   end;
end;

procedure TfPesquisas.lvResultDblClick(Sender: TObject);
var
   frmLeito: TfLeitos;
   frmMedico: TfMedicos;
   frmRemedio: TfRemedios;
   frmEspecialidade: TfEspecialidades;
   frmPaciente: TfPacientes;
   frmConsulta: TfConsulta;
   frmInternacao: TfInternacao;
   {criar essa estrutura para todos os cadastros do combobox}
begin


   if (lvResult.Selected = nil) then
      abort;

   if (lowerCase(cbParametroPesquisa.Text) = 'consulta') then
   begin

      try
         frmConsulta:= TfConsulta.create(application);

         with frmConsulta do
         begin
            {monta os dados na janela leito}
            edtId.Text:= lvResult.Selected.Caption;
            cbTipo.ItemIndex:= cbTipo.Items.IndexOf(lvResult.Selected.SubItems[0]);
            edtCodMedico.Text:= lvResult.Selected.SubItems[1];
            edtNomeMedico.Text:= lvResult.Selected.SubItems[2];
            edtCodPaciente.Text:= lvResult.Selected.SubItems[3];
            edtNomePaciente.Text:= lvResult.Selected.SubItems[4];
            edtDataConsulta.Text:= lvResult.Selected.SubItems[5];
            mmObs.Text:= lvResult.Selected.SubItems[6];

            {preenchendo os remdios no clb}
            with dm.q1 do
            begin
               close;
               sql.Clear;
               sql.Add(' select r.nomeremedio                              ');
               sql.Add(' from consulta_remedio c                           ');
               sql.Add(' join remedio r on (r.id_remedio = c.id_remedio)   ');
               sql.Add(' where c.id_consulta = :id_consulta                ');
               ParamByName('id_consulta').asInteger:= strToInt(lvResult.Selected.Caption);
               open;
            end;

            while not dm.q1.Eof do
            begin
               clbRemedios.Checked[clbRemedios.Items.IndexOf(dm.q1.fieldByName('nomeRemedio').asString)]:= true;
               dm.q1.Next;
            end;

            {habilita os componentes da tela}
            habilitarComponentes;

            {encapsular botoes}
            habilitaDesabilitaBotao(false, true, true, false);

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
         finally
            frmConsulta.free;
      end;
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'leito') then
   begin

      try
         frmLeito:= TfLeitos.create(application);

         with frmLeito do
         begin
            {monta os dados na janela leito}
            edtCodLeito.Text:= lvResult.Selected.Caption;
            cbSetor.ItemIndex:= cbSetor.Items.IndexOf(lvResult.Selected.SubItems[0]);
            edtLeito.Text:= lvResult.Selected.SubItems[1];
            edtAndar.Text:= lvResult.Selected.SubItems[2];
            edtQuarto.Text:= lvResult.Selected.SubItems[3];

            {habilita os componentes da tela}
            habilitarComponentes;

            {encapsular botoes}
            frmLeito.habilitaDesabilitaBotao(false, true, true, false);

            {muda a cor do id}
            edtCodLeito.Color:= $007a513d;
            edtCodLeito.Font.Color:= clwhite;

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
         finally
            frmleito.free;
      end;
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'medico') then
   begin
      try
         frmMedico:= TfMedicos.create(application);

         with frmMedico do
         begin
            {monta os dados na janela leito}
            edtCodMedico.Text:= lvResult.Selected.Caption;
            edtNome.Text:= lvResult.Selected.SubItems[0];
            edtCrm.Text:= lvResult.Selected.SubItems[1];
            edtCpf.Text:= lvResult.Selected.SubItems[2];

            {habilita os componentes da tela}
            habilitarComponentes;

            dm.consulta('especialidade', 'especialidade', ' where id_especialidade = ' + lvResult.Selected.SubItems[3]);
            cbEspecialidade.ItemIndex:= cbEspecialidade.Items.IndexOf(dm.cdsAux.fieldByName('especialidade').AsString);

            {encapsular botoes}
            frmMedico.habilitaDesabilitaBotao(false, true, true, false);

            {muda a cor do id}
            edtCodMedico.Color:= $007a513d;
            edtCodMedico.Font.Color:= clwhite;

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
         finally
            frmMedico.free;
      end;
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'remedio') then
   begin
      try
         frmRemedio:= TfRemedios.create(application);

         with frmRemedio do
         begin
            {monta os dados na janela leito}
            edtCodRemedio.Text:= lvResult.Selected.Caption;
            edtNomeRemedio.Text:= lvResult.Selected.SubItems[0];
            edtFabricante.Text:= lvResult.Selected.SubItems[1];
            edtValidade.Text:= lvResult.Selected.SubItems[2];
            edtValor.Text:= lvResult.Selected.SubItems[3];

            {habilita os componentes da tela}
            habilitarComponentes;

            {encapsular botoes}
            frmRemedio.habilitaDesabilitaBotao(false, true, true, false);

            {muda a cor do id}
            edtCodRemedio.Color:= $007a513d;
            edtCodRemedio.Font.Color:= clwhite;

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
         finally
            frmRemedio.free;
      end;
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'especialidade') then
   begin
      try
         frmEspecialidade:= TfEspecialidades.create(application);

         with frmEspecialidade do
         begin
            {monta os dados na janela leito}
            edtCodEspecialidade.Text:= lvResult.Selected.Caption;
            edtNomeEspecialidade.Text:= lvResult.Selected.SubItems[0];

            {habilita os componentes da tela}
            habilitarComponentes;

            {encapsular botoes}
            frmEspecialidade.habilitaDesabilitaBotao(false, true, true, false);

            {muda a cor do id}
            edtCodEspecialidade.Color:= $007a513d;
            edtCodEspecialidade.Font.Color:= clwhite;

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
         finally
            frmEspecialidade.free;
      end;
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'internacao') then
   begin
      try
         frmInternacao:= TfInternacao.create(application);

         with frmInternacao do
         begin
            {monta os dados na janela Intenacao}
            edtCodInternacao.Text:= lvResult.Selected.Caption;
            edtDataInternacao.text:= lvResult.Selected.SubItems[3];
            edtCodLeito.text:= lvResult.Selected.SubItems[5];
            edtCodConsulta.text:= lvResult.Selected.SubItems[2];
            edtDataAlta.text:= lvResult.Selected.SubItems[4];
            edtLeito.text:= lvResult.Selected.SubItems[7];
            edtSetor.text:= lvResult.Selected.SubItems[6];
            edtPaciente.Text:= lvResult.Selected.SubItems[1];

            {habilita os componentes da tela}
            habilitarComponentes;

            {encapsular botoes}
            frmInternacao.habilitaDesabilitaBotao(false, true, true, false, true, true);

            {muda a cor do id}
            edtCodInternacao.Color:= $007a513d;
            edtCodInternacao.Font.Color:= clwhite;

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
          finally
            frmInternacao.free;
          end;
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'paciente') then
   begin
      try
         frmPaciente:= TfPacientes.create(application);

         with frmPaciente do
         begin
            {monta os dados na janela leito}
            edtCodPaciente.Text:= lvResult.Selected.Caption;
            edtNomePaciente.Text:= lvResult.Selected.SubItems[0];
            cbSexo.ItemIndex:= cbSexo.Items.IndexOf(lvResult.Selected.SubItems[1]);
            edtRua.Text:= lvResult.Selected.SubItems[2];
            edtNumero.Text:= lvResult.Selected.SubItems[3];
            edtComplemento.Text:= lvResult.Selected.SubItems[4];
            edtBairro.Text:= lvResult.Selected.SubItems[5];
            edtCidade.Text:= lvResult.Selected.SubItems[6];
            cbUF.ItemIndex:= cbUF.Items.IndexOf(lvResult.Selected.SubItems[7]);
            meditDataCadastro.Text:= lvResult.Selected.SubItems[8];
            medtDataNascimento.Text:= lvResult.Selected.SubItems[9];
            medtTelefone.Text:= lvResult.Selected.SubItems[10];
            medtCelular.Text:= lvResult.Selected.SubItems[11];
            medtCPF.Text:= lvResult.Selected.SubItems[12];
            edtNomeMae.Text:= lvResult.Selected.SubItems[13];
            edtEmail.Text:= lvResult.Selected.SubItems[14];

            {habilita os componentes da tela}
            habilitarComponentes;

            {encapsular botoes}
            frmPaciente.habilitaDesabilitaBotao(false, true, true, false);

            {muda a cor do id}
            edtCodPaciente.Color:= $007a513d;
            edtCodPaciente.Font.Color:= clwhite;

            {torna-o visible false pra chamar modal}
            Visible:= false;
            ShowModal;
         end;
         finally
            frmPaciente.free;
      end;
   end;

   btnPesquisarClick(sender);
end;

procedure TfPesquisas.cbParametroPesquisaChange(Sender: TObject);
begin
   lvResult.Clear;
   cbFiltro.Clear;
   edtFiltro.Clear;

   {monta o combo com os campos de consulta de acordo com a tabela}
   if (lowerCase(cbParametroPesquisa.Text) = 'leito') then
   begin
      cbFiltro.Items.Add('Setor');
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'especialidade') then
   begin
      cbFiltro.Items.Add('Especialidade');
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'paciente') then
   begin
      cbFiltro.Items.Add('Nome');
      cbFiltro.Items.Add('Cidade');
      cbFiltro.Items.Add('Sexo');
      cbFiltro.Items.Add('Bairro');
      cbFiltro.Items.Add('Estado');
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'medico') then
   begin
      cbFiltro.Items.Add('Medico');
      cbFiltro.Items.Add('Cpf');      
   end
   else if (lowerCase(cbParametroPesquisa.Text) = 'remedio') then
      cbFiltro.Items.Add('Remedio')
   else if (lowerCase(cbParametroPesquisa.Text) = 'consulta') then
   begin
      cbFiltro.Items.Add('Paciente');
      cbFiltro.Items.Add('Medico');      
   end;
   cbFiltro.ItemIndex:= 0;
end;

procedure TfPesquisas.BitBtn2Click(Sender: TObject);
begin
   lvResult.Clear;
end;

procedure TfPesquisas.FormKeyPress(Sender: TObject; var Key: Char);
begin
   {tratamento para ir ao prximo componente da ordem de tabulao}
   if key = #13 then
   begin
      key:= #0;
      Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;

procedure TfPesquisas.AlterarRegistro1Click(Sender: TObject);
begin
   lvResultDblClick(sender);
end;

procedure TfPesquisas.ExcluirRegistro1Click(Sender: TObject);
begin
   lvResultDblClick(sender);
end;

end.
