unit uRemedios;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TfRemedios = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edtNomeRemedio: TEdit;
    edtCodRemedio: TEdit;
    btnSair: TBitBtn;
    edtFabricante: TEdit;
    edtValor: TEdit;
    Panel1: TPanel;
    Image1: TImage;
    Label6: TLabel;
    Label7: TLabel;
    btnSalvar: TBitBtn;
    btnDeletar: TBitBtn;
    btnAlterar: TBitBtn;
    btnNovo: TBitBtn;
    edtValidade: TMaskEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
    procedure edtValorExit(Sender: TObject);
  private
    { Private declarations }


  public
    { Public declarations }
    procedure desabilitarComponentes;
    procedure habilitarComponentes;
    procedure habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
    procedure gravarRegistro;
    procedure consulta(where: string);
    procedure deletaRegistro;    
    
  end;

var
  fRemedios: TfRemedios;

implementation

uses uDm;

{$R *.dfm}

procedure TfRemedios.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action:= cafree;
   fRemedios:= nil;
end;


procedure TfRemedios.habilitarComponentes;
var
   i: integer;
begin

   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= true;
         (Components[i] as tEdit).Color:= clWindow;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= true;
         (Components[i] as TComboBox).Color:= clWindow;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= true;
         (Components[i] as TMaskEdit).Color:= clWindow;
      end;
   end;
   edtCodRemedio.Color:= $007a513d;
   edtCodRemedio.Font.Color:= clWhite;
end;

procedure TfRemedios.desabilitarComponentes;
var
   i: integer;
begin

   for i:= 0 to  ComponentCount -1 do
   begin
      if Components[i] is tEdit then
      begin
         (Components[i] as tEdit).Enabled:= false;
         (Components[i] as tEdit).clear;
         (Components[i] as tEdit).Color:= clMedGray;
      end
      else if Components[i] is TComboBox then
      begin
         (Components[i] as TComboBox).Enabled:= false;
         (Components[i] as TComboBox).ItemIndex:= -1;
         (Components[i] as TComboBox).Color:= clMedGray;
      end
      else if Components[i] is TMaskEdit then
      begin
         (Components[i] as TMaskEdit).Enabled:= false;
         (Components[i] as TMaskEdit).clear;
         (Components[i] as TMaskEdit).Color:= clMedGray;
      end;
   end;
end;

procedure TfRemedios.FormCreate(Sender: TObject);
begin
   desabilitarComponentes;
   habilitaDesabilitaBotao(true, false, false, false);   
end;

procedure TfRemedios.BitBtn3Click(Sender: TObject);
begin
   habilitarComponentes;
   edtNomeRemedio.SetFocus;
end;

procedure TfRemedios.btnSairClick(Sender: TObject);
begin
   close;
end;

procedure TfRemedios.habilitaDesabilitaBotao(novo, alterar, deletar, salvar: boolean);
begin
   btnnovo.enabled:= Novo;
   btnDeletar.enabled:= deletar;
   btnAlterar.enabled:= alterar;
   btnSalvar.enabled:= salvar;
end;


procedure TfRemedios.btnNovoClick(Sender: TObject);
begin
   habilitaDesabilitaBotao(false, false, false, true);
   habilitarComponentes;

   consulta('');

   edtCodRemedio.Text:= dm.getGenerator('gen_remedio');
   dm.cds1.Insert;
   edtNomeRemedio.SetFocus;

end;

procedure TfRemedios.btnSalvarClick(Sender: TObject);
begin

   if (edtNomeRemedio.Text = '') or
      (trim(edtValidade.Text) = '/  /') or
         (edtValor.Text = '') then
   begin
      messageDlg('Os campos Nome do Remdio, Data de Validade e Valor so obrigatrios, preencha-os antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   if (not dm.convertToDate(edtValidade.Text)) then
   begin
      messageDlg('Existe um valor invlido para campo data, corrja-o antes de prosseguir', mtInformation, [mbOk], 0);
      abort;
   end;

   try
      gravarRegistro;
      messageDlg('Registro salvo com sucesso', mtInformation, [mbOk], 0);
      except on e:exception do
         messageDlg(e.message, mtError, [mbOk], 0);
   end;

   habilitaDesabilitaBotao(true, false, false, false);
   desabilitarComponentes;
end;

procedure TfRemedios.gravarRegistro;
begin
   if not dm.cds1.Active then
      raise Exception.Create('Execute uma consulta antes');

   try
      with dm.cds1 do
      begin
         Edit;
         FieldByName('id_remedio').AsInteger:= strToInt(edtCodRemedio.Text);
         FieldByName('nomeremedio').asString:= edtNomeRemedio.Text;
         FieldByName('fabricante').asString:= edtFabricante.Text;
         FieldByName('validade').asDateTime:= strToDate(edtValidade.Text);
         FieldByName('valor').asFloat:= strToFloat(edtValor.Text);
         Post;
         ApplyUpdates(-1);
      end;
      except on  e: exception do
         messageDlg('No foi possvel salvar registro' + e.Message, mtError, [mbOk], 0);
   end;
end;


procedure TfRemedios.consulta(where: string);
begin

   try
      dm.cds1.Close;
      dm.sql1.CommandText:= 'select * from remedio ' + where;
      dm.cds1.Open;
      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfRemedios.deletaRegistro;
begin

   try
      consulta(' where id_remedio = ' + edtCodRemedio.Text);
      dm.cds1.Delete;
      dm.cds1.ApplyUpdates(-1);
      desabilitarComponentes;

      messageDlg('Registro deletado com sucesso', mtInformation, [mbOk], 0);

      except on  e: exception do
         messageDlg('No foi possvel executar a consulta: ' + e.Message, mtError, [mbOk], 0);
   end;
end;

procedure TfRemedios.btnAlterarClick(Sender: TObject);
begin
   consulta(' where id_remedio = ' + edtCodRemedio.Text);
   gravarRegistro;
end;

procedure TfRemedios.btnDeletarClick(Sender: TObject);
begin
   deletaRegistro;
end;

procedure TfRemedios.edtValorExit(Sender: TObject);
begin
   edtValor.Text:= dm.ajustarFloat(edtValor.Text);
end;

end.
